var React = require('react');
module.exports = React.createClass({
	displayName: 'exports',

	getInitialState: function getInitialState() {
		return {
			indexId: null,
			primaryTable: null,
			deputyTables: [],
			baseFormItems: [{ title: '说明', name: 'zn_note', type: 'Textarea' }]
		};
	},
	componentDidMount: function componentDidMount() {
		this.__loadInfo();
	},
	__parseData: function __parseData(data) {
		var _tables = data[0],
		    _fields = data[1],
		    _table_fields = {};
		this.state.primaryTable = null;
		this.state.deputyTables = [];
		this.state.indexId = this.props.id;
		_fields.forEach(function (field) {
			if (!_table_fields[field.table_id]) {
				_table_fields[field.table_id] = [];
			}
			if (field.props) {
				field.attrs = JSON.parse(field.props);
			}
			field.value = field.field_default;
			field.data = this.__parseFieldData(field.data);
			_table_fields[field.table_id].push(field);
		}.bind(this));
		_tables.forEach(function (table) {
			table.fields = _table_fields[table.id] || [];
			if (table.parent_id) {
				this.state.deputyTables.push(table);
			} else {
				this.state.primaryTable = table;
			}
		}.bind(this));
		this.forceUpdate();
	},
	__parseFieldData: function __parseFieldData(data) {
		if (data) {
			data = eval(data);
		}

		return data;
	},
	__loadInfo: function __loadInfo() {
		if (this.props.id) {
			zn.http.post('/zn.plugin.workflow/wfindex/getIndexForm', {
				indexId: this.props.id
			}).then(function (data) {
				if (data.status == 200) {
					this.__parseData(data.result);
				} else {
					zn.toast.error(data.result);
				}
			}.bind(this), function () {
				zn.toast.error('加载失败');
			}.bind(this));
		}
	},
	__next: function __next() {
		zn.preloader.open({ title: '加载数据...' });
		zn.http.post('/zn.plugin.workflow/wfinstance/next', {
			instanceId: 10,
			nextSchemaUUID: '77C31600-353A-4A9D-B15E-25B3D13C0794'
		}).then(function (data) {
			if (data.status == 200) {
				this.setState(data);
			} else {
				zn.toast.error(data.result);
			}
			zn.preloader.close();
		}.bind(this), function () {
			zn.toast.error('加载失败');
			zn.preloader.close();
		});
	},
	getSubmitValue: function getSubmitValue() {
		var _values = {},
		    _value = null;
		for (var key in this.refs) {
			if (this.refs[key].validate) {
				_value = this.refs[key].validate();
			} else if (this.refs[key].getValue) {
				_value = this.refs[key].getValue();
			}
			if (!_value) {
				return false;
			} else {
				_values[key] = _value;
			}
		}

		return _values;
	},
	submit: function submit() {
		var _values = this.getSubmitValue();
		if (_values) {
			var _base = _values.base;
			_values.base = null;
			delete _values.base;
			zn.preloader.open({ title: '正在提交中...' });
			zn.http.post('/zn.plugin.workflow/wfindex/createInstance', {
				indexId: this.state.indexId,
				base: _base,
				data: _values
			}).then(function (data) {
				if (data.status == 200) {
					zn.notification.success('创建成功');
					this.props.onCreateSuccess && this.props.onCreateSuccess(data.result);
				} else {
					zn.notification.error('创建失败：' + data.result);
				}
				zn.preloader.close();
			}.bind(this), function () {
				zn.notification.error('调用服务器错误');
				zn.preloader.close();
			});
		} else {
			zn.notification.error('表单数据验证失败');
		}
	},
	render: function render() {
		if (!this.state.indexId) {
			return React.createElement(zn.react.DataLoader, { loader: 'timer', content: '\u6B63\u5728\u52A0\u8F7D\u4E2D...' });
		}

		return React.createElement(
			'div',
			{ className: 'zn-plugin-workflow-create-instance' },
			React.createElement(
				zn.react.Group,
				{ title: '\u8868\u5355\u4FE1\u606F' },
				this.state.primaryTable && React.createElement(zn.react.Form, { ref: this.state.primaryTable.table_name, buttons: [], items: this.state.primaryTable.fields }),
				this.state.deputyTables.map(function (deputy, index) {
					deputy.width = null;
					delete deputy.width;
					return React.createElement(
						'div',
						{ className: 'deputys' },
						React.createElement(
							'div',
							{ className: 'title' },
							deputy.zn_title
						),
						React.createElement(zn.react.EditableTable, { ref: deputy.table_name, headers: deputy.fields })
					);
				})
			),
			React.createElement(
				zn.react.Group,
				{ title: '\u6D41\u7A0B\u4FE1\u606F' },
				React.createElement(zn.react.Form, { ref: 'base', buttons: [], items: this.state.baseFormItems })
			),
			React.createElement(
				'div',
				{ style: { paddingTop: 10, overflow: 'hidden' } },
				React.createElement(zn.react.Button, { onClick: this.submit, float: 'right', text: '\u521B\u5EFA\u6D41\u7A0B\u5355\u636E', icon: 'fa-plus', style: { width: 120 } })
			)
		);
	}
});