var React = require('react');
var BaseInfo = require('./instance/BaseInfo');
var FlowStep = require('./instance/FlowStep');
var FlowTableInfo = require('./instance/FlowTableInfo');
module.exports = React.createClass({
	displayName: 'exports',

	getInitialState: function getInitialState() {
		return {
			base: null,
			current: null,
			data: null,
			table_fields: [],
			table_data: []
		};
	},
	componentDidMount: function componentDidMount() {
		this.__loadInfo();
	},
	componentDidUpdate: function componentDidUpdate(prevProps, prevState) {
		if (prevProps.instanceId != this.props.instanceId) {
			this.__loadInfo();
		}
	},
	__loadInfo: function __loadInfo() {
		if (this.props.instanceId) {
			zn.preloader.open({ title: '加载数据...' });
			zn.http.post('/zn.plugin.workflow/wfinstance/getInstance', {
				instanceId: this.props.instanceId
			}).then(function (data) {
				if (data.status == 200) {
					this.setState(data.result);
				} else {
					zn.toast.error(data.result);
				}
				zn.preloader.close();
			}.bind(this), function () {
				zn.toast.error('加载失败');
				zn.preloader.close();
			});
		}
	},
	render: function render() {
		if (!this.state.current || !this.state.base) {
			return React.createElement(
				'div',
				{ className: 'zn-plugin-workflow-instance' },
				React.createElement(
					'div',
					{ className: 'not-exist' },
					'\u6D41\u7A0B\u5B9E\u4F8BId(',
					this.props.instanceId,
					')\u4E0D\u5B58\u5728, \u8BF7\u6838\u5B9E\u540E\u518D\u8BD5!'
				)
			);
		}
		if (this.state.base.zn_rights_enabled && !this.state.base.doRights && !this.state.base.doObserveRights) {
			return React.createElement(
				'div',
				{ className: 'zn-plugin-workflow-instance' },
				React.createElement(
					'div',
					{ className: 'not-exist' },
					'\u6B64\u6D41\u7A0B\u60A8\u6682\u65E0\u3010\u6D4F\u89C8\u3011\u53CA\u3010\u64CD\u4F5C\u3011\u6743\u9650, \u8BF7\u8054\u7CFB\u7CFB\u7EDF\u7BA1\u7406\u5458\u540E\u518D\u91CD\u8BD5!'
				)
			);
		}
		return React.createElement(
			'div',
			{ className: 'zn-plugin-workflow-instance' },
			React.createElement(
				'div',
				{ className: 'index-title' },
				this.state.base.index_id_convert,
				' ',
				this.state.base.code
			),
			React.createElement(
				'div',
				{ style: { display: 'flex', justifyContent: 'space-between', padding: '0px 3px' } },
				React.createElement(
					'div',
					null,
					React.createElement(
						'span',
						null,
						'\u7533\u8BF7\u4EBA\uFF1A'
					),
					React.createElement(
						'span',
						{ style: { fontWeight: 200 } },
						this.state.base.zn_create_user_convert
					)
				),
				React.createElement(
					'div',
					null,
					React.createElement(
						'span',
						null,
						'\u7533\u8BF7\u65F6\u95F4\uFF1A'
					),
					React.createElement(
						'span',
						{ style: { fontWeight: 200 } },
						this.state.base.zn_create_time
					)
				)
			),
			this.state.table_fields && this.state.table_fields.length && React.createElement(FlowTableInfo, { fields: this.state.table_fields, data: this.state.table_data }),
			this.state.base && !!this.state.base.doRights && this.state.current && React.createElement(BaseInfo, { value: this.props.value, onNextSuccess: this.__loadInfo, base: this.state.base, current: this.state.current }),
			this.state.data && this.state.current && React.createElement(FlowStep, { data: this.state.data, current: this.state.current }),
			this.state.base.zn_note && React.createElement(
				'div',
				{ className: 'zn-plugin-workflow-panel' },
				React.createElement(
					'div',
					{ className: 'title' },
					'\u6D41\u7A0B\u5907\u6CE8'
				),
				React.createElement(
					'div',
					{ className: 'content' },
					React.createElement(
						'div',
						{ style: { minHeight: 60 } },
						this.state.base.zn_note
					)
				)
			)
		);
	}
});