var React = require('react');
module.exports = React.createClass({
	displayName: 'exports',

	getDefaultProps: function getDefaultProps() {
		return {
			model: 'ZNPluginWorkflowInstance'
		};
	},
	getInitialState: function getInitialState() {
		return {
			data: zn.store.post('/zn.plugin.admin/model/paging', {
				model: this.props.model,
				where: {
					parent_id: 0,
					index_id: this.props.indexId
				}
			}),
			items: [{ title: '流程名称', name: 'zn_title', width: 200 }, { title: '创建时间', name: 'zn_create_time', width: 130 }, { title: '说明', name: 'zn_note' }],
			toolbarItems: [{ text: '创建临时实例', name: 'wfinstance.create', icon: 'fa-plus', style: { marginRight: 5 } }, { text: '删除实例', name: 'wfinstance.delete', status: 'danger', icon: 'fa-remove', style: { marginRight: 5 } }]
		};
	},
	__doSuccess: function __doSuccess() {
		this.state.data.refresh();
	},
	__createInstance: function __createInstance() {
		var _self = this;
		zn.confirm('确认创建该流程临时实例吗？', '提示', function () {
			zn.http.post('/zn.plugin.workflow/wfindex/createInstance', {
				indexId: this.props.indexId
			}).then(function (data) {
				if (data.status == 200) {
					zn.toast.success('创建成功');
					_self.state.data.refresh();
				} else {
					zn.toast.error('创建失败: ' + data.result);
				}
			}, function (data) {
				zn.notification.error('服务器错误：创建流程失败');
			});
		}.bind(this));
	},
	__updateItem: function __updateItem(data) {
		zn.dialog({
			title: '更新用户信息',
			content: React.createElement(zn.react.Form, {
				action: '/zn.plugin.admin/model/update',
				exts: { model: this.props.model, where: { id: data.id } },
				merge: 'updates',
				data: data,
				onSubmitSuccess: this.__doSuccess,
				items: this.state.formItems })
		});
	},
	__removeItems: function __removeItems() {
		var _self = this,
		    _values = this.refs.table.getValue();
		if (_values && _values.length) {
			zn.confirm('确认删除这' + _values.length + '个用户吗？', '提示', function () {
				zn.http.post('/zn.plugin.admin/model/delete', {
					model: this.props.model,
					where: "id in (" + _values.join(',') + ")"
				}).then(function (data) {
					if (data.status == 200) {
						zn.toast.success('删除成功');
						_self.state.data.refresh();
					} else {
						zn.toast.error('删除失败: ' + data.result);
					}
				}, function (data) {
					zn.toast.error('服务器错误：删除失败');
				});
			}.bind(this));
		} else {
			zn.toast.warning('请先选择要删除的用户');
		}
	},
	__onToolbarClick: function __onToolbarClick(item) {
		switch (item.name) {
			case 'wfinstance.create':
				this.__createInstance();
				break;
			case 'wfinstance.delete':
				this.__removeItems();
				break;
		}
	},
	__onTableColumnRender: function __onTableColumnRender(rowIndex, columnIndex, data, item, value) {
		switch (columnIndex) {
			case 1:
				return React.createElement(
					'a',
					{ href: '#' + zn.react.session.fixPath('/znpluginworkflow.WFInstance') + '?instanceId=' + data.id },
					value
				);
		}
	},
	render: function render() {
		return React.createElement(
			zn.react.Page,
			{ title: '\u6D41\u7A0B\u5217\u8868', toolbarItems: this.state.toolbarItems, onToolbarClick: this.__onToolbarClick },
			React.createElement(zn.react.PagerView, {
				ref: 'table',
				view: 'Table',
				enableFilter: true,
				checkbox: 50,
				showHeader: true,
				columnRender: this.__onTableColumnRender,
				data: this.state.data,
				items: this.state.items })
		);
	}
});