var React = require('react');
module.exports = React.createClass({
	getDefaultProps: function () {
		return {
			deputyUploadEnabled: false
		};
	},
	getInitialState: function () {
		return {
			indexId: null,
			primaryTable: null,
			deputyTables: [],
			baseFormItems: [
				{ title: '说明', name: 'zn_note', type: 'Textarea' }
			]
		};
	},
	componentDidMount: function (){
		this.__loadInfo();
	},
	__parseData: function (data){
		var _tables = data[0],
		 	_fields = data[1],
			_table_fields = {};
		this.state.primaryTable = null;
		this.state.deputyTables = [];
		this.state.indexId = this.props.id;
		_fields.forEach(function (field){
			if(!_table_fields[field.table_id]){
				_table_fields[field.table_id] = [];
			}
			if(field.attrs){
				field.attrs = JSON.parse(field.attrs);
			}
			if(field.props){
				zn.extend(field, JSON.parse(field.props));
			}
			field.value = field.default_value || field.field_default;
			field.data = this.__parseFieldData(field.data);
			_table_fields[field.table_id].push(field);
		}.bind(this));
		_tables.forEach(function (table){
			table.fields = _table_fields[table.id] || [];
			table.data = table.data || [];
			if(table.parent_id){
				if(table.is_input){
					this.state.deputyTables.push(table);
				}
			}else {
				this.state.primaryTable = table;
			}
		}.bind(this));

		if(this.props.data && this.props.data.length){
			this.props.data.forEach(function (items, index){
				this.state.deputyTables[index].data = items;
			}.bind(this));
		}
		this.forceUpdate();
	},
	__parseFieldData: function (data){
		if(!data){
			return data;
		}

		if(data.indexOf('javascript:') == 0){
			return eval(data);
		}else if(data.indexOf('json:')) {
			return JSON.parse(data.substring(5));
		}

		return data;
	},
	__loadInfo: function (){
		if(this.props.id){
			zn.http.post('/zn.plugin.workflow/wfindex/getIndexForm', {
				indexId: this.props.id
			}).then(function (data){
				if(data.status==200){
					this.__parseData(data.result);
				}else {
					zn.toast.error(data.result);
				}
			}.bind(this), function (){
				zn.toast.error('加载失败');
			}.bind(this));
		}
	},
	__next: function (){
		zn.preloader.open({ title: '加载数据...' });
		zn.http.post('/zn.plugin.workflow/wfinstance/next', {
			instanceId: 10,
			nextSchemaUUID: '77C31600-353A-4A9D-B15E-25B3D13C0794'
		}).then(function (data){
			if(data.status==200){
				this.setState(data);
			}else {
				zn.toast.error(data.result);
			}
			zn.preloader.close();
		}.bind(this), function (){
			zn.toast.error('加载失败');
			zn.preloader.close();
		});
	},
	getSubmitValue: function (){
		var _values = {},
			_value = null;
		for(var key in this.refs){
			if(this.refs[key].validate){
				_value = this.refs[key].validate();
			}else if(this.refs[key].getValue){
				_value = this.refs[key].getValue();
			}
			if(!_value){
				return false;
			}else {
				_values[key] = _value;
			}
		}

		return _values;
	},
	submit: function (){
		var _values = this.getSubmitValue();
		if(_values){
			var _base = _values.base;
			_values.base = null;
			delete _values.base;
			zn.preloader.open({ title: '正在提交中...' });
			zn.http.post('/zn.plugin.workflow/wfindex/createInstance', {
				indexId: this.state.indexId,
				base: _base,
				data: _values
			}).then(function (data){
				if(data.status == 200){
					zn.notification.success('创建成功');
					var _result = this.props.onCreateSuccess && this.props.onCreateSuccess(data.result);
					if(!this.props.onCreateSuccess || _result !== false){
						zn.react.session.relativeJump('/znpluginworkflow.WFInstance?instanceId=' + data.result);
					}
				}else {
					zn.notification.error('创建失败：' + data.result);
				}
				zn.preloader.close();
			}.bind(this), function (){
				zn.notification.error('调用服务器错误');
				zn.preloader.close();
			});
		}else {
			zn.notification.error('表单数据验证失败');
		}
	},
	__onChange: function (files){
		var _file = files[0];
		if(_file.name.indexOf('xls')==-1){
			return (zn.notification.error || window.alert).call(null, '文件[' + _file.name + ']不是 xlsx / xls 类型'), false;
		}
	},
	__onComplete: function (data, uploader, index){
		this.state.deputyTables[index].data = (this.state.deputyTables[index].data||[]).concat(data[0].values);
		this.forceUpdate();
		this.props.onComplete && this.props.onComplete(data, uploader);
	},
	__onError: function (msg){
		zn.notification.error('Import Error: ' + msg);
		this.props.onError && this.props.onError(msg);
	},
	render: function(){
		if(!this.state.indexId){
			return <zn.react.DataLoader loader="timer" content="正在加载中..." />;
		}
		return (
			<div className="zn-plugin-workflow-create-instance" >
				<zn.react.Group title="表单信息" >
					{
						this.state.primaryTable && <zn.react.Form value={this.props.baseValue||{}} ref={this.state.primaryTable.table_name} buttons={[]} items={this.state.primaryTable.fields}/>
					}
					{
						this.state.deputyTables.map(function (deputy, index){
							deputy.width = null;
							delete deputy.width;
							return <div className="deputys">
								<div className="title">
									<span>{deputy.zn_title}</span>
									{
										(this.props.deputyUploadEnabled || !!deputy.import_enabled) && <div className="btns">
											<a className="btn" href={zn.http.fixURL('/zn.plugin.workflow/wfindextable/exportTableExcelTemplate?tableId='+deputy.id)}>
												<i className="icon fa fa-download zr-padding-3" />
												<span>Excel数据模板下载</span>
											</a>
											<zn.react.AjaxUploader
												action="/zn.plugin.workflow/wfindextable/importTableExcelData"
												hiddens={{
													tableId: deputy.id
												}}
												onChange={this.__onChange}
												onError={this.__onError}
												onComplete={(data, uploader)=>this.__onComplete(data, uploader, index)}
												multipart={false} >
												<div className="btn">
													<i className="icon fa fa-upload zr-padding-3" />
													<span>Excel表格导入</span>
												</div>
											</zn.react.AjaxUploader>
										</div>
									}
								</div>
								<div className="table">
									<zn.react.EditableTable ref={deputy.table_name} headers={deputy.fields} data={deputy.data} />
								</div>
							</div>
						}.bind(this))
					}
				</zn.react.Group>
				<zn.react.Group title="流程信息" >
					<zn.react.Form ref="base" buttons={[]} items={this.state.baseFormItems}/>
				</zn.react.Group>
				<div style={{paddingTop: 10, overflow: 'hidden'}}>
					<zn.react.Button onClick={this.submit} float="right" text="创建流程单据" icon="fa-plus" style={{width: 120}} />
				</div>
			</div>
		);
	}
});
