var React = require('react');
var BaseInfo = require('./instance/BaseInfo');
var FlowStep = require('./instance/FlowStep');
var FlowTableInfo = require('./instance/FlowTableInfo');
module.exports = React.createClass({
	getInitialState: function () {
		return {
			base: null,
			current: null,
			data: null,
			table_fields: [],
			table_data: []
		};
	},
	componentDidMount: function (){
		this.__loadInfo();
	},
	componentDidUpdate: function (prevProps, prevState){
		if(prevProps.instanceId!=this.props.instanceId){
			this.__loadInfo();
		}
	},
	__loadInfo: function (){
		if(this.props.instanceId){
			zn.preloader.open({ title: '加载数据...' });
			zn.http.post('/zn.plugin.workflow/wfinstance/getInstance', {
				instanceId: this.props.instanceId
			}).then(function (data){
				if(data.status==200){
					this.setState(data.result);
				}else {
					zn.toast.error(data.result);
				}
				zn.preloader.close();
			}.bind(this), function (){
				zn.toast.error('加载失败');
				zn.preloader.close();
			});
		}
	},
	render:function(){
		if(!this.state.current || !this.state.base){
			return <div className="zn-plugin-workflow-instance" >
				<div className="not-exist">流程实例Id({this.props.instanceId})不存在, 请核实后再试!</div>
			</div>;
		}
		if(this.state.base.zn_rights_enabled && !this.state.base.doRights && !this.state.base.doObserveRights){
			return <div className="zn-plugin-workflow-instance" >
				<div className="not-exist">此流程您暂无【浏览】及【操作】权限, 请联系系统管理员后再重试!</div>
			</div>;
		}
		return (
			<div className="zn-plugin-workflow-instance" >
				<div className="index-title">{this.state.base.index_id_convert} {this.state.base.code}</div>
				<div style={{ display: 'flex', justifyContent: 'space-between', padding: '0px 3px' }}>
					<div><span>申请人：</span><span style={{ fontWeight: 200 }}>{this.state.base.zn_create_user_convert}</span></div>
					<div><span>申请时间：</span><span style={{ fontWeight: 200 }}>{this.state.base.zn_create_time}</span></div>
				</div>
				{(this.state.table_fields && !!this.state.table_fields.length) && <FlowTableInfo fields={this.state.table_fields} data={this.state.table_data} />}
				{(this.state.base && !!this.state.base.doRights && this.state.current) && <BaseInfo value={this.props.value} onNextSuccess={this.__loadInfo} base={this.state.base} current={this.state.current} />}
				{(this.state.data && this.state.current) && <FlowStep data={this.state.data} current={this.state.current} />}
				{
					this.state.base.zn_note && <div className="zn-plugin-workflow-panel" >
						<div className="title">流程备注</div>
						<div className="content">
							<div style={{ minHeight: 60 }}>{this.state.base.zn_note}</div>
						</div>
					</div>
				}
			</div>
		);
	}
});
